// (c) J Dean Brock, 2006

package boundedfigure ;

public abstract class BoundedBox {
     
    public abstract int getXBound() ;
    public abstract int getYBound() ;
    public abstract int getWidthBound() ;
    public abstract int getHeightBound() ;
    
    public boolean insideBoundedBox(int x, int y) {
        int xb = getXBound() ;
        int yb = getYBound() ;
        int wb = getWidthBound() ;
        int hb = getHeightBound() ;
        return xb <= x && x <= xb+wb && yb <= y && y <= yb+hb ;
    }
    
    public boolean intersectsBoundedBox(BoundedBox bb) {
        int xb = bb.getXBound() ;
        int yb = bb.getYBound() ;
        int wb = bb.getWidthBound() ;
        int hb = bb.getHeightBound() ;  
        return insideBoundedBox(xb,    yb)
            || insideBoundedBox(xb+wb, yb)
            || insideBoundedBox(xb,    yb+hb)
            || insideBoundedBox(xb+wb, yb+hb)
            || bb.insideBoundedBox(getXBound(), getYBound());
    }
}
