package boundedfigure;

public class Rectangle extends BoundedBox implements Intersector {
    
    private int x, y, width, height ;

    public Rectangle() {
        setX(0) ; 
        setY(0) ;
        setWidth(2) ;
        setHeight(2) ;
    }

    public Rectangle(int x, int y, int width, int height)
            throws IllegalArgumentException {
        setX(x) ; 
        setY(y) ;
        setWidth(width) ;
        setHeight(height) ;
    }
    
    public void setX(int x) {
        this.x = x ;
    }
    
    public int getX() {
        return x ;
    }
    
    public void setY(int y) {
        this.y = y ;
    }
    
    public int getY() {
        return y ;
    }
    
    public void setWidth(int width) throws IllegalArgumentException {
        if (width<0)
            throw new IllegalArgumentException("Negative width") ;
        this.width = width ;
    }
    
    public int getWidth() {
        return width ;
    }
    
    public void setHeight(int height) {
        if (height<0)
            throw new IllegalArgumentException("Negative height") ;
        this.height = height ;
    }
    
    public int getHeight() {
        return height ;
    }
    
    public int getXBound() {
        return x ;
    }
    public int getYBound() {
        return y ;
    }
    public int getWidthBound() {
        return width ;
    }
    public int getHeightBound() {
        return height ;
    }
    
    public boolean intersects(Object obj) {
        if (obj instanceof Rectangle) {
            Rectangle r2 = (Rectangle) obj ;
            return intersectsBoundedBox(r2) ;
        } else if (obj instanceof Circle) {
            return ((Circle)obj).intersects(this) ;
        } else {
            String excpMsg = "Don't know how to intersect Rectangle and "
                   + obj.getClass().getName() ;
            throw new IllegalArgumentException(excpMsg) ;
        }
    }
    
    public boolean inside(int x, int y) {
        return insideBoundedBox(x, y) ;
    }
}
